package ru.zvzd3d.EKG.NikyEkgSD1;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.content.ContextWrapper.*;

import android.util.Log;

import android.app.Service;
import android.os.IBinder;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.ParcelUuid;
import android.app.Activity;
import android.support.v4.app.ActivityCompat;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;

import android.Manifest;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.IntentFilter;

import android.widget.TextView;

import android.location.Criteria;
import android.location.GpsStatus.NmeaListener;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import java.util.List;
import java.util.Set;



public class CHeatWriterThread extends Thread 
{
  private BluetoothSocket m_Socket;
  private Handler m_handler;
  private InputStream m_InStream;
  private OutputStream m_OutStream;
  
  public volatile long m_RcvBytes;
  public volatile long m_RcvCount;
  
  private OEkgDataRcv m_pEkgRcv;
  
  public int m_MyBTMode = 0;
  
  public CHeatWriterThread(BluetoothSocket Socket, Handler handler, OEkgDataRcv pEkgRcv)
  {
	m_Socket = Socket;
	m_handler = handler;
	m_InStream = null;
	m_OutStream = null;
	m_RcvBytes = 0;
	m_RcvCount = 0;
	m_pEkgRcv = pEkgRcv;
  };
  
  public boolean SendMy(byte Cmd[])
  {
	if (m_OutStream == null) return false;
	try 
    {
		m_OutStream.write(Cmd);
		m_OutStream.flush();
    } 
    catch (IOException e) 
    {
  	  return false;
    }; 	
	return true;
  };
  
  public boolean ExternStop()
  {
	  //      ,   , ,    
	  try 
	  {
		  m_Socket.close();	    
	  } 
	  catch (IOException e) 
	  {
	    return false;
	  }; 	
	  return true;  
  };
  
  
  
  @Override
  public void run() 
  {
	/*try 
	{
	  sleep(2000);
	} 
	catch (InterruptedException e1) 
	{
	}; */
	
    try 
    {
      m_Socket.connect();	    
    } 
    catch (IOException e) 
    {
  	  StopMyThread("connect " + e.getMessage());
	  return;
    }; 
    
    //  ,   
    m_handler.sendEmptyMessage(33);
    
    try 
    {
      m_InStream = m_Socket.getInputStream();
   	  m_OutStream = m_Socket.getOutputStream();
    } 
    catch (Exception e) 
    { 
      StopMyThread("getInputStream: " + e.getMessage());
  	  return;  
    };
    

    byte[] buffer = new byte[8192];  // buffer store for the stream
  
    // Keep listening to the InputStream until an exception occurs
    while (true) 
    {
  	  try 
   	  {
  		m_RcvCount++;
  		// Read from the InputStream
        int bytes = m_InStream.read(buffer);		
        //h.obtainMessage(RECIEVE_MESSAGE, bytes, -1, buffer).sendToTarget();		//     Handler
        //Print(" : " + bytes + "\n");
        m_RcvBytes += bytes;        
        
        m_pEkgRcv.ProcessDataRcvYogaDrumsBT(buffer, bytes, m_MyBTMode);
      } 
  	  catch (IOException e) 
  	  {
  		StopMyThread("read: " + e.getMessage());
    	return;
      };
    }
  };

  //  ,    
  //         run()
  //
  private void StopMyThread(String s)
  {
	m_InStream = null;
	m_OutStream = null;
	
	try 
 	{
	  m_Socket.close();
 	}
	catch (Exception e) 
	{
	};
	
	m_Socket = null;
	
	Message msg = m_handler.obtainMessage(111, 0,0, s);
    m_handler.sendMessage(msg);
  };  	  
};
